org.eclipse.viatra.query.runtime.matchers.context

## Interface IQueryRuntimeContext

- All Known Implementing Classes:
    AbstractQueryRuntimeContext, DynamicEMFQueryRuntimeContext, EMFQueryRuntimeContext, SimpleRuntimeContext, TabularRuntimeContext

      public interface IQueryRuntimeContext

  Provides instance model information (relations corresponding to input keys) to query evaluator backends at runtime. Implementors shall extend `AbstractQueryRuntimeContext` instead directly this interface.
  No Implement:
    This interface is not intended to be implemented by clients. Extend `AbstractQueryRuntimeContext` instead.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addUpdateListener(IInputKey key, Tuple seed, IQueryRuntimeContextListener listener)` Subscribes for updates in the extensional relation identified by the input key, optionally seeded with the given tuple.
    `<V> V` | `coalesceTraversals(java.util.concurrent.Callable<V> callable)` The given callable will be executed, and all model traversals will be delayed until the execution is done.
    `boolean` | `containsTuple(IInputKey key, ITuple seed)` Simpler form of `#enumerateTuples(IInputKey, TupleMask, Tuple)` in the case where all values of the tuples are bound by the seed.
    `int` | `countTuples(IInputKey key, TupleMask seedMask, ITuple seed)` Returns the number of tuples in the extensional relation identified by the input key seeded with the given mask and tuple.
    `void` | `ensureIndexed(IInputKey key, IndexingService service)` If the given (enumerable) input key is not yet indexed, the model will be traversed (after the end of the outermost coalescing block, see `coalesceTraversals(Callable)`) so that the index can be built.
    `void` | `ensureWildcardIndexing(IndexingService service)` Starts wildcard indexing for the given service.
    `java.lang.Iterable<Tuple>` | `enumerateTuples(IInputKey key, TupleMask seedMask, ITuple seed)` Returns the tuples in the extensional relation identified by the input key, optionally seeded with the given tuple.
    `java.lang.Iterable<? extends java.lang.Object>` | `enumerateValues(IInputKey key, TupleMask seedMask, ITuple seed)` Simpler form of `#enumerateTuples(IInputKey, TupleMask, Tuple)` in the case where all values of the tuples are bound by the seed except for one.
    `default java.util.Optional<java.lang.Double>` | `estimateAverageBucketSize(IInputKey key, TupleMask groupMask, Accuracy requiredAccuracy)` Gives an estimate of the average size of different groups the tuples of the given relation are projected into by the given mask (e.g.
    `java.util.Optional<java.lang.Long>` | `estimateCardinality(IInputKey key, TupleMask groupMask, Accuracy requiredAccuracy)` Gives an estimate of the number of different groups the tuples of the given relation are projected into by the given mask (e.g.
    `void` | `executeAfterTraversal(java.lang.Runnable runnable)` Execute the given runnable after traversal.
    `IQueryMetaContext` | `getMetaContext()` Provides metamodel-specific info independent of the runtime instance model.
    `boolean` | `isCoalescing()`
    `boolean` | `isIndexed(IInputKey key, IndexingService service)` Returns true if index is available for the given key providing the given service.
    `void` | `removeUpdateListener(IInputKey key, Tuple seed, IQueryRuntimeContextListener listener)` Unsubscribes from updates in the extensional relation identified by the input key, optionally seeded with the given tuple.
    `java.lang.Object` | `unwrapElement(java.lang.Object internalElement)` Unwraps the internal representation of the element into its original form
    `Tuple` | `unwrapTuple(Tuple internalElements)` Unwraps the tuple of internal representations of elements into their original forms
    `java.lang.Object` | `wrapElement(java.lang.Object externalElement)` Wraps the external element into the internal representation that is to be used by the query backend
    `Tuple` | `wrapTuple(Tuple externalElements)` Unwraps the tuple of elements into the internal representation that is to be used by the query backend

- - ### Method Detail

    - #### getMetaContext

          IQueryMetaContext getMetaContext()

      Provides metamodel-specific info independent of the runtime instance model.

    - #### coalesceTraversals

          <V> V coalesceTraversals(java.util.concurrent.Callable<V> callable)
                            throws java.lang.reflect.InvocationTargetException

      The given callable will be executed, and all model traversals will be delayed until the execution is done. If there are any outstanding information to be read from the model, a single coalesced model traversal will initialize the caches and deliver the notifications.

      Calls may be nested. A single coalesced traversal will happen at the end of the outermost call.

      Caution: results returned by the runtime context may be incomplete during the coalescing period, to be corrected by notifications sent during the final coalesced traversal. For example, if a certain input key is not cached yet, an empty relation may be reported during `callable.call()`; the cache will be constructed after the call terminates and notifications will deliver the entire content of the relation. Non-incremental query backends should therefore never enumerate input keys while coalesced (verify using `isCoalescing()`).

      Parameters:
        `callable` -
      Throws:
        `java.lang.reflect.InvocationTargetException`

    - #### isCoalescing

          boolean isCoalescing()

      Returns:
        true iff currently within a coalescing section (i.e. within the callable of a call to `coalesceTraversals(Callable)`).

    - #### isIndexed

          boolean isIndexed(IInputKey key,
                            IndexingService service)

      Returns true if index is available for the given key providing the given service.
      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable or an unknown type, see `IQueryMetaContext.isEnumerable(IInputKey)`.
      Since:
        1.4

    - #### ensureIndexed

          void ensureIndexed(IInputKey key,
                             IndexingService service)

      If the given (enumerable) input key is not yet indexed, the model will be traversed (after the end of the outermost coalescing block, see `coalesceTraversals(Callable)`) so that the index can be built. It is possible that the base indexer will select a higher indexing level merging multiple indexing requests to an appropriate level.

      Postcondition: After invoking this method, `#getIndexed(IInputKey, IndexingService)` for the same key and service will be guaranteed to return the requested or a highing indexing level as soon as `isCoalescing()` first returns false.

      Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable or an unknown type, see `IQueryMetaContext.isEnumerable(IInputKey)`.
      Since:
        1.4

    - #### countTuples

          int countTuples(IInputKey key,
                          TupleMask seedMask,
                          ITuple seed)

      Returns the number of tuples in the extensional relation identified by the input key seeded with the given mask and tuple.
      Parameters:
        `key` - an input key
        `seedMask` - a mask that extracts those parameters of the input key (from the entire parameter list) that should be bound to a fixed value; must not be null. Note: any given index must occur at most once in seedMask.
        `seed` - the tuple of fixed values restricting the match set to be considered, in the same order as given in parameterSeedMask, so that for each considered match tuple, projectedParameterSeed.equals(parameterSeedMask.transform(match)) should hold. Must not be null.
      Returns:
        the number of tuples in the model for the given key and seed

        Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.
      Since:
        1.7

    - #### estimateCardinality

          java.util.Optional<java.lang.Long> estimateCardinality(IInputKey key,
                                                                 TupleMask groupMask,
                                                                 Accuracy requiredAccuracy)

      Gives an estimate of the number of different groups the tuples of the given relation are projected into by the given mask (e.g. for an identity mask, this means the full relation size). The estimate must meet the required accuracy.

      Must accept any input key, even non-enumerables or those not recognized by this runtime context. If there is insufficient information to provide an answer up to the required precision, `Optional.empty()` is returned.

      PRE: `TupleMask.isNonrepeating()` must hold for the group mask.

      Returns:
        if available, an estimate of the cardinality of the projection of the given extensional relation, with the desired accuracy.
      Since:
        2.1

    - #### estimateAverageBucketSize

          default java.util.Optional<java.lang.Double> estimateAverageBucketSize(IInputKey key,
                                                                                 TupleMask groupMask,
                                                                                 Accuracy requiredAccuracy)

      Gives an estimate of the average size of different groups the tuples of the given relation are projected into by the given mask (e.g. for an identity mask, this means 1, while for an empty mask, the result is the full relation size). The estimate must meet the required accuracy.

      Must accept any input key, even non-enumerables or those not recognized by this runtime context. If there is insufficient information to provide an answer up to the required precision, `Optional.empty()` may be returned.

      For an empty relation, zero is acceptable as an exact answer.

      PRE: `TupleMask.isNonrepeating()` must hold for the group mask.

      Returns:
        if available, an estimate of the average size of each projection group of the given extensional relation, with the desired accuracy.
      Since:
        2.1

    - #### enumerateTuples

          java.lang.Iterable<Tuple> enumerateTuples(IInputKey key,
                                                    TupleMask seedMask,
                                                    ITuple seed)

      Returns the tuples in the extensional relation identified by the input key, optionally seeded with the given tuple.
      Parameters:
        `key` - an input key
        `seedMask` - a mask that extracts those parameters of the input key (from the entire parameter list) that should be bound to a fixed value; must not be null. Note: any given index must occur at most once in seedMask.
        `seed` - the tuple of fixed values restricting the match set to be considered, in the same order as given in parameterSeedMask, so that for each considered match tuple, projectedParameterSeed.equals(parameterSeedMask.transform(match)) should hold. Must not be null.
      Returns:
        the tuples in the model for the given key and seed

        Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.
      Since:
        1.7

    - #### enumerateValues

          java.lang.Iterable<? extends java.lang.Object> enumerateValues(IInputKey key,
                                                                         TupleMask seedMask,
                                                                         ITuple seed)

      Simpler form of `#enumerateTuples(IInputKey, TupleMask, Tuple)` in the case where all values of the tuples are bound by the seed except for one.

      Selects the tuples in the extensional relation identified by the input key, optionally seeded with the given tuple, and then returns the single value from each tuple which is not bound by the ssed mask.

      Parameters:
        `key` - an input key
        `seedMask` - a mask that extracts those parameters of the input key (from the entire parameter list) that should be bound to a fixed value; must not be null. Note: any given index must occur at most once in seedMask, and seedMask must include all parameters in any arbitrary order except one.
        `seed` - the tuple of fixed values restricting the match set to be considered, in the same order as given in parameterSeedMask, so that for each considered match tuple, projectedParameterSeed.equals(parameterSeedMask.transform(match)) should hold. Must not be null.
      Returns:
        the objects in the model for the given key and seed

        Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.
      Since:
        1.7

    - #### containsTuple

          boolean containsTuple(IInputKey key,
                                ITuple seed)

      Simpler form of `#enumerateTuples(IInputKey, TupleMask, Tuple)` in the case where all values of the tuples are bound by the seed.

      Returns whether the given tuple is in the extensional relation identified by the input key.

      Note: this call works for non-enumerable input keys as well.

      Parameters:
        `key` - an input key
        `seed` - the tuple of fixed values restricting the match set to be considered, in the same order as given in parameterSeedMask, so that for each considered match tuple, projectedParameterSeed.equals(parameterSeedMask.transform(match)) should hold. Must not be null.
      Returns:
        true iff there is at least a single tuple contained in the relation that corresponds to the seed tuple
      Since:
        2.0

    - #### addUpdateListener

          void addUpdateListener(IInputKey key,
                                 Tuple seed,
                                 IQueryRuntimeContextListener listener)

      Subscribes for updates in the extensional relation identified by the input key, optionally seeded with the given tuple.

      This should be called after invoking

      Parameters:
        `key` - an input key
        `seed` - can be null or a tuple with matching arity; if non-null, only those updates in the model are notified about that match the seed at positions where the seed is non-null.
        `listener` - will be notified of future changes

        Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

    - #### removeUpdateListener

          void removeUpdateListener(IInputKey key,
                                    Tuple seed,
                                    IQueryRuntimeContextListener listener)

      Unsubscribes from updates in the extensional relation identified by the input key, optionally seeded with the given tuple.
      Parameters:
        `key` - an input key
        `seed` - can be null or a tuple with matching arity; if non-null, only those updates in the model are notified about that match the seed at positions where the seed is non-null.
        `listener` - will no longer be notified of future changes

        Precondition: the given key is enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

      Throws:
        `java.lang.IllegalArgumentException` - if key is not enumerable, see `IQueryMetaContext.isEnumerable(IInputKey)`.

    - #### wrapElement

          java.lang.Object wrapElement(java.lang.Object externalElement)

      Wraps the external element into the internal representation that is to be used by the query backend

      model element -> internal object.

      null must be mapped to null.

    - #### unwrapElement

          java.lang.Object unwrapElement(java.lang.Object internalElement)

      Unwraps the internal representation of the element into its original form

      internal object -> model element

      null must be mapped to null.

    - #### wrapTuple

          Tuple wrapTuple(Tuple externalElements)

      Unwraps the tuple of elements into the internal representation that is to be used by the query backend

      model elements -> internal objects

      null must be mapped to null.

    - #### unwrapTuple

          Tuple unwrapTuple(Tuple internalElements)

      Unwraps the tuple of internal representations of elements into their original forms

      internal objects -> model elements

      null must be mapped to null.

    - #### ensureWildcardIndexing

          void ensureWildcardIndexing(IndexingService service)

      Starts wildcard indexing for the given service. After this call, no registration is required for this `IndexingService`. a previously set wildcard level cannot be lowered, only extended.
      Since:
        1.4

    - #### executeAfterTraversal

          void executeAfterTraversal(java.lang.Runnable runnable)
                              throws java.lang.reflect.InvocationTargetException

      Execute the given runnable after traversal. It is guaranteed that the runnable is executed as soon as the indexing is finished. The callback is executed only once, then is removed from the callback queue.
      Parameters:
        `traversalCallback` -
      Throws:
        `java.lang.reflect.InvocationTargetException`
      Since:
        1.4